JmxMetaMapBuilder (groovy 2.4.10 API)
Date: 2017-03-14

Package: groovy.jmx.builder

## [Groovy] Class JmxMetaMapBuilder

- groovy.jmx.builder.JmxMetaMapBuilder

- The JmxMetaMapBuilder class is used to collect meta data passed in JmxBuilder nodes. Once collected, the data is then normalized to be represented uniformly regardless of the resource where it was obtained.

  Authors:
    Vladimir Vivien

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `static Map` | `buildAttributeMapFrom(def object)` Builds attribute meta map with default information from an instance of an object.
    `` | `static Map` | `buildAttributeMapFrom(def object, def descCollection)` Sanitizes and builds an attribute meta map from a descriptor collection.
    `` | `static Map` | `buildConstructorMapFrom(def object)` Returns a meta map of constructors from given object.
    `` | `static Map` | `buildConstructorMapFrom(def object, def descCollection)` Builds a fully normalized constructor meta map.
    `` | `static def` | `buildListenerMapFrom(def descCollection)` Creates a fully-normalized meta map for a given collection of listeners.
    `` | `static Map` | `buildObjectMapFrom(def object)` Builds a complete meta map graph for the specified object using default values.
    `` | `static Map` | `buildObjectMapFrom(def object, def descriptor)` Builds a complete meta map graph for a given target and descriptor.
    `` | `static Map` | `buildOperationMapFrom(def object)` Returns a meta map of operations from given object.
    `` | `static Map` | `buildOperationMapFrom(def object, def descCollection)`
    `` | `static Map` | `buildParameterMapFrom(def method)` Builds a normalized parameter meta map for all params on provided method.
    `` | `static Map` | `buildParameterMapFrom(def method, def descCollection)` Builds a fully normalized parameter meta map for the method and the given meta map.
    `` | `static Map` | `createListenerMap(def descriptor)` Builds normalized meta map of the provided listener descriptor.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Method Detail

    - #### static Map buildAttributeMapFrom(def object)

      Builds attribute meta map with default information from an instance of an object.

      Returns:
        the meta map for the attribute
      Parameters:
        `the` - object from which attribute info will be retrieved

    - #### static Map buildAttributeMapFrom(def object, def descCollection)

      Sanitizes and builds an attribute meta map from a descriptor collection. The collection can either be a map of the form [attribName:[descriptor...],...] or [attribName1,...attribNameN]. The code guests sensible defaults when values are not provided

      Returns:
        a Map of meta information about the object.
      Parameters:
        `the` - object about which meta data is collected
        `descriptor` - collection: either a map or a list

    - #### static Map buildConstructorMapFrom(def object)

      Returns a meta map of constructors from given object.

      Returns:
        The meta map generated.
      Parameters:
        `object` - to profile

    - #### static Map buildConstructorMapFrom(def object, def descCollection)

      Builds a fully normalized constructor meta map.

      Returns:
        a normalized meta map for the constructor
      Parameters:
        `the` - object where constructor is defined.
        `the` - meta map that will be normalized

    - #### static def buildListenerMapFrom(def descCollection)

      Creates a fully-normalized meta map for a given collection of listeners.

      Parameters:
        `-` - collection of descriptors to normalize
      See Also:
        JmxMetaMapBuilder.createListenerMap

    - #### static Map buildObjectMapFrom(def object)

      Builds a complete meta map graph for the specified object using default values. All generated attributes are set to read-only.

      Returns:
        fully-realized meta map of the object
      Parameters:
        `object` - used to build meta data graph
      See Also:
        buildAttributeMapFrom(Object)
        buildConstructorMapFrom(Object)
        buildOperationMapFrom(Object)

    - #### static Map buildObjectMapFrom(def object, def descriptor)

      Builds a complete meta map graph for a given target and descriptor.

      Returns:
        fully-realized meta map of the object
      Parameters:
        `object` - used to build meta data graph
        `descriptor` - a full descriptor map describing object attributes and ops.
      See Also:
        buildAttributeMapFrom(Object, Map)
        buildConstructorMapFrom(Object, Map)
        buildOperationMapFrom(Object, Map)

    - #### static Map buildOperationMapFrom(def object)

      Returns a meta map of operations from given object.

      Returns:
        The meta map generated.
      Parameters:
        `object` - to profile

    - #### static Map buildOperationMapFrom(def object, def descCollection)

    - #### static Map buildParameterMapFrom(def method)

      Builds a normalized parameter meta map for all params on provided method.

      Returns:
        the normalized map
      Parameters:
        `the` - method with parameters to normalized

    - #### static Map buildParameterMapFrom(def method, def descCollection)

      Builds a fully normalized parameter meta map for the method and the given meta map.

      Returns:
        the normalized map
      Parameters:
        `the` - method from which to extract normalized info.
        `a` - given meta map which will be normalized

    - #### static Map createListenerMap(def descriptor)

      Builds normalized meta map of the provided listener descriptor.

      Returns:
        - fully normalized meta map of listener data.
      Parameters:
        `descriptor` - - descriptive data collected from JmxBuilder listener nodes.